package br.mp.mprj.portal.portlet.gestaomensagens.service.model;

import com.liferay.portal.kernel.bean.AutoEscape;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;

import java.io.Serializable;

import java.util.Date;

/**
 * The base model interface for the Agendamento service. Represents a row in the &quot;PRT_GESTMSG_AGENDAMENTO&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This interface and its corresponding implementation {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoModelImpl} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoImpl}.
 * </p>
 *
 * @author Henrique Simoes
 * @see Agendamento
 * @see br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoImpl
 * @see br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoModelImpl
 * @generated
 */
public interface AgendamentoModel extends BaseModel<Agendamento> {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this interface directly. All methods that expect a agendamento model instance should use the {@link Agendamento} interface instead.
     */

    /**
     * Returns the primary key of this agendamento.
     *
     * @return the primary key of this agendamento
     */
    public long getPrimaryKey();

    /**
     * Sets the primary key of this agendamento.
     *
     * @param primaryKey the primary key of this agendamento
     */
    public void setPrimaryKey(long primaryKey);

    /**
     * Returns the uuid of this agendamento.
     *
     * @return the uuid of this agendamento
     */
    @AutoEscape
    public String getUuid();

    /**
     * Sets the uuid of this agendamento.
     *
     * @param uuid the uuid of this agendamento
     */
    public void setUuid(String uuid);

    /**
     * Returns the agendamento ID of this agendamento.
     *
     * @return the agendamento ID of this agendamento
     */
    public long getAgendamentoId();

    /**
     * Sets the agendamento ID of this agendamento.
     *
     * @param agendamentoId the agendamento ID of this agendamento
     */
    public void setAgendamentoId(long agendamentoId);

    /**
     * Returns the mensagem ID of this agendamento.
     *
     * @return the mensagem ID of this agendamento
     */
    public long getMensagemId();

    /**
     * Sets the mensagem ID of this agendamento.
     *
     * @param mensagemId the mensagem ID of this agendamento
     */
    public void setMensagemId(long mensagemId);

    /**
     * Returns the company ID of this agendamento.
     *
     * @return the company ID of this agendamento
     */
    public long getCompanyId();

    /**
     * Sets the company ID of this agendamento.
     *
     * @param companyId the company ID of this agendamento
     */
    public void setCompanyId(long companyId);

    /**
     * Returns the group ID of this agendamento.
     *
     * @return the group ID of this agendamento
     */
    public long getGroupId();

    /**
     * Sets the group ID of this agendamento.
     *
     * @param groupId the group ID of this agendamento
     */
    public void setGroupId(long groupId);

    /**
     * Returns the tipo agendamento of this agendamento.
     *
     * @return the tipo agendamento of this agendamento
     */
    public int getTipoAgendamento();

    /**
     * Sets the tipo agendamento of this agendamento.
     *
     * @param tipoAgendamento the tipo agendamento of this agendamento
     */
    public void setTipoAgendamento(int tipoAgendamento);

    /**
     * Returns the data calendario of this agendamento.
     *
     * @return the data calendario of this agendamento
     */
    public Date getDataCalendario();

    /**
     * Sets the data calendario of this agendamento.
     *
     * @param dataCalendario the data calendario of this agendamento
     */
    public void setDataCalendario(Date dataCalendario);

    /**
     * Returns the data inicio of this agendamento.
     *
     * @return the data inicio of this agendamento
     */
    public Date getDataInicio();

    /**
     * Sets the data inicio of this agendamento.
     *
     * @param dataInicio the data inicio of this agendamento
     */
    public void setDataInicio(Date dataInicio);

    /**
     * Returns the data fim of this agendamento.
     *
     * @return the data fim of this agendamento
     */
    public Date getDataFim();

    /**
     * Sets the data fim of this agendamento.
     *
     * @param dataFim the data fim of this agendamento
     */
    public void setDataFim(Date dataFim);

    /**
     * Returns the padrao recorrencia of this agendamento.
     *
     * @return the padrao recorrencia of this agendamento
     */
    public int getPadraoRecorrencia();

    /**
     * Sets the padrao recorrencia of this agendamento.
     *
     * @param padraoRecorrencia the padrao recorrencia of this agendamento
     */
    public void setPadraoRecorrencia(int padraoRecorrencia);

    /**
     * Returns the frequencia of this agendamento.
     *
     * @return the frequencia of this agendamento
     */
    public int getFrequencia();

    /**
     * Sets the frequencia of this agendamento.
     *
     * @param frequencia the frequencia of this agendamento
     */
    public void setFrequencia(int frequencia);

    /**
     * Returns the diario todos of this agendamento.
     *
     * @return the diario todos of this agendamento
     */
    public boolean getDiarioTodos();

    /**
     * Returns <code>true</code> if this agendamento is diario todos.
     *
     * @return <code>true</code> if this agendamento is diario todos; <code>false</code> otherwise
     */
    public boolean isDiarioTodos();

    /**
     * Sets whether this agendamento is diario todos.
     *
     * @param diarioTodos the diario todos of this agendamento
     */
    public void setDiarioTodos(boolean diarioTodos);

    /**
     * Returns the semanal dias of this agendamento.
     *
     * @return the semanal dias of this agendamento
     */
    @AutoEscape
    public String getSemanalDias();

    /**
     * Sets the semanal dias of this agendamento.
     *
     * @param semanalDias the semanal dias of this agendamento
     */
    public void setSemanalDias(String semanalDias);

    /**
     * Returns the mensal dia frequencia of this agendamento.
     *
     * @return the mensal dia frequencia of this agendamento
     */
    public int getMensalDiaFrequencia();

    /**
     * Sets the mensal dia frequencia of this agendamento.
     *
     * @param mensalDiaFrequencia the mensal dia frequencia of this agendamento
     */
    public void setMensalDiaFrequencia(int mensalDiaFrequencia);

    /**
     * Returns the data atualizacao of this agendamento.
     *
     * @return the data atualizacao of this agendamento
     */
    public Date getDataAtualizacao();

    /**
     * Sets the data atualizacao of this agendamento.
     *
     * @param dataAtualizacao the data atualizacao of this agendamento
     */
    public void setDataAtualizacao(Date dataAtualizacao);

    /**
     * Returns the data envio of this agendamento.
     *
     * @return the data envio of this agendamento
     */
    public Date getDataEnvio();

    /**
     * Sets the data envio of this agendamento.
     *
     * @param dataEnvio the data envio of this agendamento
     */
    public void setDataEnvio(Date dataEnvio);

    /**
     * Returns the situacao envio of this agendamento.
     *
     * @return the situacao envio of this agendamento
     */
    public int getSituacaoEnvio();

    /**
     * Sets the situacao envio of this agendamento.
     *
     * @param situacaoEnvio the situacao envio of this agendamento
     */
    public void setSituacaoEnvio(int situacaoEnvio);

    /**
     * Returns the erro envio of this agendamento.
     *
     * @return the erro envio of this agendamento
     */
    public boolean getErroEnvio();

    /**
     * Returns <code>true</code> if this agendamento is erro envio.
     *
     * @return <code>true</code> if this agendamento is erro envio; <code>false</code> otherwise
     */
    public boolean isErroEnvio();

    /**
     * Sets whether this agendamento is erro envio.
     *
     * @param erroEnvio the erro envio of this agendamento
     */
    public void setErroEnvio(boolean erroEnvio);

    /**
     * Returns the mensagem erro of this agendamento.
     *
     * @return the mensagem erro of this agendamento
     */
    @AutoEscape
    public String getMensagemErro();

    /**
     * Sets the mensagem erro of this agendamento.
     *
     * @param mensagemErro the mensagem erro of this agendamento
     */
    public void setMensagemErro(String mensagemErro);

    @Override
    public boolean isNew();

    @Override
    public void setNew(boolean n);

    @Override
    public boolean isCachedModel();

    @Override
    public void setCachedModel(boolean cachedModel);

    @Override
    public boolean isEscapedModel();

    @Override
    public Serializable getPrimaryKeyObj();

    @Override
    public void setPrimaryKeyObj(Serializable primaryKeyObj);

    @Override
    public ExpandoBridge getExpandoBridge();

    @Override
    public void setExpandoBridgeAttributes(BaseModel<?> baseModel);

    @Override
    public void setExpandoBridgeAttributes(ExpandoBridge expandoBridge);

    @Override
    public void setExpandoBridgeAttributes(ServiceContext serviceContext);

    @Override
    public Object clone();

    @Override
    public int compareTo(
        br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento agendamento);

    @Override
    public int hashCode();

    @Override
    public CacheModel<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> toCacheModel();

    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento toEscapedModel();

    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento toUnescapedModel();

    @Override
    public String toString();

    @Override
    public String toXmlString();
}
