package br.mp.mprj.portal.portlet.gestaomensagens.service.model;

import com.liferay.portal.kernel.bean.AutoEscape;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;

import java.io.Serializable;

import java.util.Date;

/**
 * The base model interface for the Mensagem service. Represents a row in the &quot;PRT_GESTMSG_MENSAGEM&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This interface and its corresponding implementation {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.MensagemModelImpl} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.MensagemImpl}.
 * </p>
 *
 * @author Henrique Simoes
 * @see Mensagem
 * @see br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.MensagemImpl
 * @see br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.MensagemModelImpl
 * @generated
 */
public interface MensagemModel extends BaseModel<Mensagem> {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this interface directly. All methods that expect a mensagem model instance should use the {@link Mensagem} interface instead.
     */

    /**
     * Returns the primary key of this mensagem.
     *
     * @return the primary key of this mensagem
     */
    public long getPrimaryKey();

    /**
     * Sets the primary key of this mensagem.
     *
     * @param primaryKey the primary key of this mensagem
     */
    public void setPrimaryKey(long primaryKey);

    /**
     * Returns the uuid of this mensagem.
     *
     * @return the uuid of this mensagem
     */
    @AutoEscape
    public String getUuid();

    /**
     * Sets the uuid of this mensagem.
     *
     * @param uuid the uuid of this mensagem
     */
    public void setUuid(String uuid);

    /**
     * Returns the mensagem ID of this mensagem.
     *
     * @return the mensagem ID of this mensagem
     */
    public long getMensagemId();

    /**
     * Sets the mensagem ID of this mensagem.
     *
     * @param mensagemId the mensagem ID of this mensagem
     */
    public void setMensagemId(long mensagemId);

    /**
     * Returns the company ID of this mensagem.
     *
     * @return the company ID of this mensagem
     */
    public long getCompanyId();

    /**
     * Sets the company ID of this mensagem.
     *
     * @param companyId the company ID of this mensagem
     */
    public void setCompanyId(long companyId);

    /**
     * Returns the group ID of this mensagem.
     *
     * @return the group ID of this mensagem
     */
    public long getGroupId();

    /**
     * Sets the group ID of this mensagem.
     *
     * @param groupId the group ID of this mensagem
     */
    public void setGroupId(long groupId);

    /**
     * Returns the template ID of this mensagem.
     *
     * @return the template ID of this mensagem
     */
    public long getTemplateId();

    /**
     * Sets the template ID of this mensagem.
     *
     * @param templateId the template ID of this mensagem
     */
    public void setTemplateId(long templateId);

    /**
     * Returns the grupo destinatario IDs of this mensagem.
     *
     * @return the grupo destinatario IDs of this mensagem
     */
    @AutoEscape
    public String getGrupoDestinatarioIds();

    /**
     * Sets the grupo destinatario IDs of this mensagem.
     *
     * @param grupoDestinatarioIds the grupo destinatario IDs of this mensagem
     */
    public void setGrupoDestinatarioIds(String grupoDestinatarioIds);

    /**
     * Returns the conta saida ID of this mensagem.
     *
     * @return the conta saida ID of this mensagem
     */
    public long getContaSaidaId();

    /**
     * Sets the conta saida ID of this mensagem.
     *
     * @param contaSaidaId the conta saida ID of this mensagem
     */
    public void setContaSaidaId(long contaSaidaId);

    /**
     * Returns the codigo mensagem of this mensagem.
     *
     * @return the codigo mensagem of this mensagem
     */
    @AutoEscape
    public String getCodigoMensagem();

    /**
     * Sets the codigo mensagem of this mensagem.
     *
     * @param codigoMensagem the codigo mensagem of this mensagem
     */
    public void setCodigoMensagem(String codigoMensagem);

    /**
     * Returns the assunto of this mensagem.
     *
     * @return the assunto of this mensagem
     */
    @AutoEscape
    public String getAssunto();

    /**
     * Sets the assunto of this mensagem.
     *
     * @param assunto the assunto of this mensagem
     */
    public void setAssunto(String assunto);

    /**
     * Returns the conteudo of this mensagem.
     *
     * @return the conteudo of this mensagem
     */
    @AutoEscape
    public String getConteudo();

    /**
     * Sets the conteudo of this mensagem.
     *
     * @param conteudo the conteudo of this mensagem
     */
    public void setConteudo(String conteudo);

    /**
     * Returns the prioridade of this mensagem.
     *
     * @return the prioridade of this mensagem
     */
    public int getPrioridade();

    /**
     * Sets the prioridade of this mensagem.
     *
     * @param prioridade the prioridade of this mensagem
     */
    public void setPrioridade(int prioridade);

    /**
     * Returns the ativo of this mensagem.
     *
     * @return the ativo of this mensagem
     */
    public boolean getAtivo();

    /**
     * Returns <code>true</code> if this mensagem is ativo.
     *
     * @return <code>true</code> if this mensagem is ativo; <code>false</code> otherwise
     */
    public boolean isAtivo();

    /**
     * Sets whether this mensagem is ativo.
     *
     * @param ativo the ativo of this mensagem
     */
    public void setAtivo(boolean ativo);

    /**
     * Returns the tipo envio of this mensagem.
     *
     * @return the tipo envio of this mensagem
     */
    public int getTipoEnvio();

    /**
     * Sets the tipo envio of this mensagem.
     *
     * @param tipoEnvio the tipo envio of this mensagem
     */
    public void setTipoEnvio(int tipoEnvio);

    /**
     * Returns the situacao envio of this mensagem.
     *
     * @return the situacao envio of this mensagem
     */
    public int getSituacaoEnvio();

    /**
     * Sets the situacao envio of this mensagem.
     *
     * @param situacaoEnvio the situacao envio of this mensagem
     */
    public void setSituacaoEnvio(int situacaoEnvio);

    /**
     * Returns the nome solicitante of this mensagem.
     *
     * @return the nome solicitante of this mensagem
     */
    @AutoEscape
    public String getNomeSolicitante();

    /**
     * Sets the nome solicitante of this mensagem.
     *
     * @param nomeSolicitante the nome solicitante of this mensagem
     */
    public void setNomeSolicitante(String nomeSolicitante);

    /**
     * Returns the user ID criador of this mensagem.
     *
     * @return the user ID criador of this mensagem
     */
    public long getUserIdCriador();

    /**
     * Sets the user ID criador of this mensagem.
     *
     * @param userIdCriador the user ID criador of this mensagem
     */
    public void setUserIdCriador(long userIdCriador);

    /**
     * Returns the data solicitacao of this mensagem.
     *
     * @return the data solicitacao of this mensagem
     */
    public Date getDataSolicitacao();

    /**
     * Sets the data solicitacao of this mensagem.
     *
     * @param dataSolicitacao the data solicitacao of this mensagem
     */
    public void setDataSolicitacao(Date dataSolicitacao);

    /**
     * Returns the data ultimo envio of this mensagem.
     *
     * @return the data ultimo envio of this mensagem
     */
    public Date getDataUltimoEnvio();

    /**
     * Sets the data ultimo envio of this mensagem.
     *
     * @param dataUltimoEnvio the data ultimo envio of this mensagem
     */
    public void setDataUltimoEnvio(Date dataUltimoEnvio);

    /**
     * Returns the data alteracao of this mensagem.
     *
     * @return the data alteracao of this mensagem
     */
    public Date getDataAlteracao();

    /**
     * Sets the data alteracao of this mensagem.
     *
     * @param dataAlteracao the data alteracao of this mensagem
     */
    public void setDataAlteracao(Date dataAlteracao);

    /**
     * Returns the rascunho of this mensagem.
     *
     * @return the rascunho of this mensagem
     */
    public boolean getRascunho();

    /**
     * Returns <code>true</code> if this mensagem is rascunho.
     *
     * @return <code>true</code> if this mensagem is rascunho; <code>false</code> otherwise
     */
    public boolean isRascunho();

    /**
     * Sets whether this mensagem is rascunho.
     *
     * @param rascunho the rascunho of this mensagem
     */
    public void setRascunho(boolean rascunho);

    /**
     * Returns the status workflow of this mensagem.
     *
     * @return the status workflow of this mensagem
     */
    public int getStatusWorkflow();

    /**
     * Sets the status workflow of this mensagem.
     *
     * @param statusWorkflow the status workflow of this mensagem
     */
    public void setStatusWorkflow(int statusWorkflow);

    /**
     * Returns the user ID workflow of this mensagem.
     *
     * @return the user ID workflow of this mensagem
     */
    public long getUserIdWorkflow();

    /**
     * Sets the user ID workflow of this mensagem.
     *
     * @param userIdWorkflow the user ID workflow of this mensagem
     */
    public void setUserIdWorkflow(long userIdWorkflow);

    /**
     * Returns the data status workflow of this mensagem.
     *
     * @return the data status workflow of this mensagem
     */
    public Date getDataStatusWorkflow();

    /**
     * Sets the data status workflow of this mensagem.
     *
     * @param dataStatusWorkflow the data status workflow of this mensagem
     */
    public void setDataStatusWorkflow(Date dataStatusWorkflow);

    /**
     * Returns the comentario workflow of this mensagem.
     *
     * @return the comentario workflow of this mensagem
     */
    @AutoEscape
    public String getComentarioWorkflow();

    /**
     * Sets the comentario workflow of this mensagem.
     *
     * @param comentarioWorkflow the comentario workflow of this mensagem
     */
    public void setComentarioWorkflow(String comentarioWorkflow);

    /**
     * Returns the clonagem pai of this mensagem.
     *
     * @return the clonagem pai of this mensagem
     */
    public long getClonagemPai();

    /**
     * Sets the clonagem pai of this mensagem.
     *
     * @param clonagemPai the clonagem pai of this mensagem
     */
    public void setClonagemPai(long clonagemPai);

    /**
     * Returns the literal agendamento of this mensagem.
     *
     * @return the literal agendamento of this mensagem
     */
    @AutoEscape
    public String getLiteralAgendamento();

    /**
     * Sets the literal agendamento of this mensagem.
     *
     * @param literalAgendamento the literal agendamento of this mensagem
     */
    public void setLiteralAgendamento(String literalAgendamento);

    /**
     * Returns the user ID cancel of this mensagem.
     *
     * @return the user ID cancel of this mensagem
     */
    public long getUserIdCancel();

    /**
     * Sets the user ID cancel of this mensagem.
     *
     * @param userIdCancel the user ID cancel of this mensagem
     */
    public void setUserIdCancel(long userIdCancel);

    /**
     * Returns the user ID aprovador of this mensagem.
     *
     * @return the user ID aprovador of this mensagem
     */
    public long getUserIdAprovador();

    /**
     * Sets the user ID aprovador of this mensagem.
     *
     * @param userIdAprovador the user ID aprovador of this mensagem
     */
    public void setUserIdAprovador(long userIdAprovador);

    /**
     * Returns the user ID reprovador of this mensagem.
     *
     * @return the user ID reprovador of this mensagem
     */
    public long getUserIdReprovador();

    /**
     * Sets the user ID reprovador of this mensagem.
     *
     * @param userIdReprovador the user ID reprovador of this mensagem
     */
    public void setUserIdReprovador(long userIdReprovador);

    /**
     * Returns the data cancel of this mensagem.
     *
     * @return the data cancel of this mensagem
     */
    public Date getDataCancel();

    /**
     * Sets the data cancel of this mensagem.
     *
     * @param dataCancel the data cancel of this mensagem
     */
    public void setDataCancel(Date dataCancel);

    /**
     * Returns the service of this mensagem.
     *
     * @return the service of this mensagem
     */
    public boolean getService();

    /**
     * Returns <code>true</code> if this mensagem is service.
     *
     * @return <code>true</code> if this mensagem is service; <code>false</code> otherwise
     */
    public boolean isService();

    /**
     * Sets whether this mensagem is service.
     *
     * @param service the service of this mensagem
     */
    public void setService(boolean service);

    @Override
    public boolean isNew();

    @Override
    public void setNew(boolean n);

    @Override
    public boolean isCachedModel();

    @Override
    public void setCachedModel(boolean cachedModel);

    @Override
    public boolean isEscapedModel();

    @Override
    public Serializable getPrimaryKeyObj();

    @Override
    public void setPrimaryKeyObj(Serializable primaryKeyObj);

    @Override
    public ExpandoBridge getExpandoBridge();

    @Override
    public void setExpandoBridgeAttributes(BaseModel<?> baseModel);

    @Override
    public void setExpandoBridgeAttributes(ExpandoBridge expandoBridge);

    @Override
    public void setExpandoBridgeAttributes(ServiceContext serviceContext);

    @Override
    public Object clone();

    @Override
    public int compareTo(
        br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem mensagem);

    @Override
    public int hashCode();

    @Override
    public CacheModel<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem> toCacheModel();

    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem toEscapedModel();

    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem toUnescapedModel();

    @Override
    public String toString();

    @Override
    public String toXmlString();
}
