package br.mp.mprj.portal.portlet.gestaomensagens.service.model;

import com.liferay.portal.kernel.util.Validator;
import com.liferay.portal.model.ModelWrapper;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * <p>
 * This class is a wrapper for {@link Mensagem}.
 * </p>
 *
 * @author Henrique Simoes
 * @see Mensagem
 * @generated
 */
public class MensagemWrapper implements Mensagem, ModelWrapper<Mensagem> {
    private Mensagem _mensagem;

    public MensagemWrapper(Mensagem mensagem) {
        _mensagem = mensagem;
    }

    @Override
    public Class<?> getModelClass() {
        return Mensagem.class;
    }

    @Override
    public String getModelClassName() {
        return Mensagem.class.getName();
    }

    @Override
    public Map<String, Object> getModelAttributes() {
        Map<String, Object> attributes = new HashMap<String, Object>();

        attributes.put("uuid", getUuid());
        attributes.put("mensagemId", getMensagemId());
        attributes.put("companyId", getCompanyId());
        attributes.put("groupId", getGroupId());
        attributes.put("templateId", getTemplateId());
        attributes.put("grupoDestinatarioIds", getGrupoDestinatarioIds());
        attributes.put("contaSaidaId", getContaSaidaId());
        attributes.put("codigoMensagem", getCodigoMensagem());
        attributes.put("assunto", getAssunto());
        attributes.put("conteudo", getConteudo());
        attributes.put("prioridade", getPrioridade());
        attributes.put("ativo", getAtivo());
        attributes.put("tipoEnvio", getTipoEnvio());
        attributes.put("situacaoEnvio", getSituacaoEnvio());
        attributes.put("nomeSolicitante", getNomeSolicitante());
        attributes.put("userIdCriador", getUserIdCriador());
        attributes.put("dataSolicitacao", getDataSolicitacao());
        attributes.put("dataUltimoEnvio", getDataUltimoEnvio());
        attributes.put("dataAlteracao", getDataAlteracao());
        attributes.put("rascunho", getRascunho());
        attributes.put("statusWorkflow", getStatusWorkflow());
        attributes.put("userIdWorkflow", getUserIdWorkflow());
        attributes.put("dataStatusWorkflow", getDataStatusWorkflow());
        attributes.put("comentarioWorkflow", getComentarioWorkflow());
        attributes.put("clonagemPai", getClonagemPai());
        attributes.put("literalAgendamento", getLiteralAgendamento());
        attributes.put("userIdCancel", getUserIdCancel());
        attributes.put("userIdAprovador", getUserIdAprovador());
        attributes.put("userIdReprovador", getUserIdReprovador());
        attributes.put("dataCancel", getDataCancel());
        attributes.put("service", getService());

        return attributes;
    }

    @Override
    public void setModelAttributes(Map<String, Object> attributes) {
        String uuid = (String) attributes.get("uuid");

        if (uuid != null) {
            setUuid(uuid);
        }

        Long mensagemId = (Long) attributes.get("mensagemId");

        if (mensagemId != null) {
            setMensagemId(mensagemId);
        }

        Long companyId = (Long) attributes.get("companyId");

        if (companyId != null) {
            setCompanyId(companyId);
        }

        Long groupId = (Long) attributes.get("groupId");

        if (groupId != null) {
            setGroupId(groupId);
        }

        Long templateId = (Long) attributes.get("templateId");

        if (templateId != null) {
            setTemplateId(templateId);
        }

        String grupoDestinatarioIds = (String) attributes.get(
                "grupoDestinatarioIds");

        if (grupoDestinatarioIds != null) {
            setGrupoDestinatarioIds(grupoDestinatarioIds);
        }

        Long contaSaidaId = (Long) attributes.get("contaSaidaId");

        if (contaSaidaId != null) {
            setContaSaidaId(contaSaidaId);
        }

        String codigoMensagem = (String) attributes.get("codigoMensagem");

        if (codigoMensagem != null) {
            setCodigoMensagem(codigoMensagem);
        }

        String assunto = (String) attributes.get("assunto");

        if (assunto != null) {
            setAssunto(assunto);
        }

        String conteudo = (String) attributes.get("conteudo");

        if (conteudo != null) {
            setConteudo(conteudo);
        }

        Integer prioridade = (Integer) attributes.get("prioridade");

        if (prioridade != null) {
            setPrioridade(prioridade);
        }

        Boolean ativo = (Boolean) attributes.get("ativo");

        if (ativo != null) {
            setAtivo(ativo);
        }

        Integer tipoEnvio = (Integer) attributes.get("tipoEnvio");

        if (tipoEnvio != null) {
            setTipoEnvio(tipoEnvio);
        }

        Integer situacaoEnvio = (Integer) attributes.get("situacaoEnvio");

        if (situacaoEnvio != null) {
            setSituacaoEnvio(situacaoEnvio);
        }

        String nomeSolicitante = (String) attributes.get("nomeSolicitante");

        if (nomeSolicitante != null) {
            setNomeSolicitante(nomeSolicitante);
        }

        Long userIdCriador = (Long) attributes.get("userIdCriador");

        if (userIdCriador != null) {
            setUserIdCriador(userIdCriador);
        }

        Date dataSolicitacao = (Date) attributes.get("dataSolicitacao");

        if (dataSolicitacao != null) {
            setDataSolicitacao(dataSolicitacao);
        }

        Date dataUltimoEnvio = (Date) attributes.get("dataUltimoEnvio");

        if (dataUltimoEnvio != null) {
            setDataUltimoEnvio(dataUltimoEnvio);
        }

        Date dataAlteracao = (Date) attributes.get("dataAlteracao");

        if (dataAlteracao != null) {
            setDataAlteracao(dataAlteracao);
        }

        Boolean rascunho = (Boolean) attributes.get("rascunho");

        if (rascunho != null) {
            setRascunho(rascunho);
        }

        Integer statusWorkflow = (Integer) attributes.get("statusWorkflow");

        if (statusWorkflow != null) {
            setStatusWorkflow(statusWorkflow);
        }

        Long userIdWorkflow = (Long) attributes.get("userIdWorkflow");

        if (userIdWorkflow != null) {
            setUserIdWorkflow(userIdWorkflow);
        }

        Date dataStatusWorkflow = (Date) attributes.get("dataStatusWorkflow");

        if (dataStatusWorkflow != null) {
            setDataStatusWorkflow(dataStatusWorkflow);
        }

        String comentarioWorkflow = (String) attributes.get(
                "comentarioWorkflow");

        if (comentarioWorkflow != null) {
            setComentarioWorkflow(comentarioWorkflow);
        }

        Long clonagemPai = (Long) attributes.get("clonagemPai");

        if (clonagemPai != null) {
            setClonagemPai(clonagemPai);
        }

        String literalAgendamento = (String) attributes.get(
                "literalAgendamento");

        if (literalAgendamento != null) {
            setLiteralAgendamento(literalAgendamento);
        }

        Long userIdCancel = (Long) attributes.get("userIdCancel");

        if (userIdCancel != null) {
            setUserIdCancel(userIdCancel);
        }

        Long userIdAprovador = (Long) attributes.get("userIdAprovador");

        if (userIdAprovador != null) {
            setUserIdAprovador(userIdAprovador);
        }

        Long userIdReprovador = (Long) attributes.get("userIdReprovador");

        if (userIdReprovador != null) {
            setUserIdReprovador(userIdReprovador);
        }

        Date dataCancel = (Date) attributes.get("dataCancel");

        if (dataCancel != null) {
            setDataCancel(dataCancel);
        }

        Boolean service = (Boolean) attributes.get("service");

        if (service != null) {
            setService(service);
        }
    }

    /**
    * Returns the primary key of this mensagem.
    *
    * @return the primary key of this mensagem
    */
    @Override
    public long getPrimaryKey() {
        return _mensagem.getPrimaryKey();
    }

    /**
    * Sets the primary key of this mensagem.
    *
    * @param primaryKey the primary key of this mensagem
    */
    @Override
    public void setPrimaryKey(long primaryKey) {
        _mensagem.setPrimaryKey(primaryKey);
    }

    /**
    * Returns the uuid of this mensagem.
    *
    * @return the uuid of this mensagem
    */
    @Override
    public java.lang.String getUuid() {
        return _mensagem.getUuid();
    }

    /**
    * Sets the uuid of this mensagem.
    *
    * @param uuid the uuid of this mensagem
    */
    @Override
    public void setUuid(java.lang.String uuid) {
        _mensagem.setUuid(uuid);
    }

    /**
    * Returns the mensagem ID of this mensagem.
    *
    * @return the mensagem ID of this mensagem
    */
    @Override
    public long getMensagemId() {
        return _mensagem.getMensagemId();
    }

    /**
    * Sets the mensagem ID of this mensagem.
    *
    * @param mensagemId the mensagem ID of this mensagem
    */
    @Override
    public void setMensagemId(long mensagemId) {
        _mensagem.setMensagemId(mensagemId);
    }

    /**
    * Returns the company ID of this mensagem.
    *
    * @return the company ID of this mensagem
    */
    @Override
    public long getCompanyId() {
        return _mensagem.getCompanyId();
    }

    /**
    * Sets the company ID of this mensagem.
    *
    * @param companyId the company ID of this mensagem
    */
    @Override
    public void setCompanyId(long companyId) {
        _mensagem.setCompanyId(companyId);
    }

    /**
    * Returns the group ID of this mensagem.
    *
    * @return the group ID of this mensagem
    */
    @Override
    public long getGroupId() {
        return _mensagem.getGroupId();
    }

    /**
    * Sets the group ID of this mensagem.
    *
    * @param groupId the group ID of this mensagem
    */
    @Override
    public void setGroupId(long groupId) {
        _mensagem.setGroupId(groupId);
    }

    /**
    * Returns the template ID of this mensagem.
    *
    * @return the template ID of this mensagem
    */
    @Override
    public long getTemplateId() {
        return _mensagem.getTemplateId();
    }

    /**
    * Sets the template ID of this mensagem.
    *
    * @param templateId the template ID of this mensagem
    */
    @Override
    public void setTemplateId(long templateId) {
        _mensagem.setTemplateId(templateId);
    }

    /**
    * Returns the grupo destinatario IDs of this mensagem.
    *
    * @return the grupo destinatario IDs of this mensagem
    */
    @Override
    public java.lang.String getGrupoDestinatarioIds() {
        return _mensagem.getGrupoDestinatarioIds();
    }

    /**
    * Sets the grupo destinatario IDs of this mensagem.
    *
    * @param grupoDestinatarioIds the grupo destinatario IDs of this mensagem
    */
    @Override
    public void setGrupoDestinatarioIds(java.lang.String grupoDestinatarioIds) {
        _mensagem.setGrupoDestinatarioIds(grupoDestinatarioIds);
    }

    /**
    * Returns the conta saida ID of this mensagem.
    *
    * @return the conta saida ID of this mensagem
    */
    @Override
    public long getContaSaidaId() {
        return _mensagem.getContaSaidaId();
    }

    /**
    * Sets the conta saida ID of this mensagem.
    *
    * @param contaSaidaId the conta saida ID of this mensagem
    */
    @Override
    public void setContaSaidaId(long contaSaidaId) {
        _mensagem.setContaSaidaId(contaSaidaId);
    }

    /**
    * Returns the codigo mensagem of this mensagem.
    *
    * @return the codigo mensagem of this mensagem
    */
    @Override
    public java.lang.String getCodigoMensagem() {
        return _mensagem.getCodigoMensagem();
    }

    /**
    * Sets the codigo mensagem of this mensagem.
    *
    * @param codigoMensagem the codigo mensagem of this mensagem
    */
    @Override
    public void setCodigoMensagem(java.lang.String codigoMensagem) {
        _mensagem.setCodigoMensagem(codigoMensagem);
    }

    /**
    * Returns the assunto of this mensagem.
    *
    * @return the assunto of this mensagem
    */
    @Override
    public java.lang.String getAssunto() {
        return _mensagem.getAssunto();
    }

    /**
    * Sets the assunto of this mensagem.
    *
    * @param assunto the assunto of this mensagem
    */
    @Override
    public void setAssunto(java.lang.String assunto) {
        _mensagem.setAssunto(assunto);
    }

    /**
    * Returns the conteudo of this mensagem.
    *
    * @return the conteudo of this mensagem
    */
    @Override
    public java.lang.String getConteudo() {
        return _mensagem.getConteudo();
    }

    /**
    * Sets the conteudo of this mensagem.
    *
    * @param conteudo the conteudo of this mensagem
    */
    @Override
    public void setConteudo(java.lang.String conteudo) {
        _mensagem.setConteudo(conteudo);
    }

    /**
    * Returns the prioridade of this mensagem.
    *
    * @return the prioridade of this mensagem
    */
    @Override
    public int getPrioridade() {
        return _mensagem.getPrioridade();
    }

    /**
    * Sets the prioridade of this mensagem.
    *
    * @param prioridade the prioridade of this mensagem
    */
    @Override
    public void setPrioridade(int prioridade) {
        _mensagem.setPrioridade(prioridade);
    }

    /**
    * Returns the ativo of this mensagem.
    *
    * @return the ativo of this mensagem
    */
    @Override
    public boolean getAtivo() {
        return _mensagem.getAtivo();
    }

    /**
    * Returns <code>true</code> if this mensagem is ativo.
    *
    * @return <code>true</code> if this mensagem is ativo; <code>false</code> otherwise
    */
    @Override
    public boolean isAtivo() {
        return _mensagem.isAtivo();
    }

    /**
    * Sets whether this mensagem is ativo.
    *
    * @param ativo the ativo of this mensagem
    */
    @Override
    public void setAtivo(boolean ativo) {
        _mensagem.setAtivo(ativo);
    }

    /**
    * Returns the tipo envio of this mensagem.
    *
    * @return the tipo envio of this mensagem
    */
    @Override
    public int getTipoEnvio() {
        return _mensagem.getTipoEnvio();
    }

    /**
    * Sets the tipo envio of this mensagem.
    *
    * @param tipoEnvio the tipo envio of this mensagem
    */
    @Override
    public void setTipoEnvio(int tipoEnvio) {
        _mensagem.setTipoEnvio(tipoEnvio);
    }

    /**
    * Returns the situacao envio of this mensagem.
    *
    * @return the situacao envio of this mensagem
    */
    @Override
    public int getSituacaoEnvio() {
        return _mensagem.getSituacaoEnvio();
    }

    /**
    * Sets the situacao envio of this mensagem.
    *
    * @param situacaoEnvio the situacao envio of this mensagem
    */
    @Override
    public void setSituacaoEnvio(int situacaoEnvio) {
        _mensagem.setSituacaoEnvio(situacaoEnvio);
    }

    /**
    * Returns the nome solicitante of this mensagem.
    *
    * @return the nome solicitante of this mensagem
    */
    @Override
    public java.lang.String getNomeSolicitante() {
        return _mensagem.getNomeSolicitante();
    }

    /**
    * Sets the nome solicitante of this mensagem.
    *
    * @param nomeSolicitante the nome solicitante of this mensagem
    */
    @Override
    public void setNomeSolicitante(java.lang.String nomeSolicitante) {
        _mensagem.setNomeSolicitante(nomeSolicitante);
    }

    /**
    * Returns the user ID criador of this mensagem.
    *
    * @return the user ID criador of this mensagem
    */
    @Override
    public long getUserIdCriador() {
        return _mensagem.getUserIdCriador();
    }

    /**
    * Sets the user ID criador of this mensagem.
    *
    * @param userIdCriador the user ID criador of this mensagem
    */
    @Override
    public void setUserIdCriador(long userIdCriador) {
        _mensagem.setUserIdCriador(userIdCriador);
    }

    /**
    * Returns the data solicitacao of this mensagem.
    *
    * @return the data solicitacao of this mensagem
    */
    @Override
    public java.util.Date getDataSolicitacao() {
        return _mensagem.getDataSolicitacao();
    }

    /**
    * Sets the data solicitacao of this mensagem.
    *
    * @param dataSolicitacao the data solicitacao of this mensagem
    */
    @Override
    public void setDataSolicitacao(java.util.Date dataSolicitacao) {
        _mensagem.setDataSolicitacao(dataSolicitacao);
    }

    /**
    * Returns the data ultimo envio of this mensagem.
    *
    * @return the data ultimo envio of this mensagem
    */
    @Override
    public java.util.Date getDataUltimoEnvio() {
        return _mensagem.getDataUltimoEnvio();
    }

    /**
    * Sets the data ultimo envio of this mensagem.
    *
    * @param dataUltimoEnvio the data ultimo envio of this mensagem
    */
    @Override
    public void setDataUltimoEnvio(java.util.Date dataUltimoEnvio) {
        _mensagem.setDataUltimoEnvio(dataUltimoEnvio);
    }

    /**
    * Returns the data alteracao of this mensagem.
    *
    * @return the data alteracao of this mensagem
    */
    @Override
    public java.util.Date getDataAlteracao() {
        return _mensagem.getDataAlteracao();
    }

    /**
    * Sets the data alteracao of this mensagem.
    *
    * @param dataAlteracao the data alteracao of this mensagem
    */
    @Override
    public void setDataAlteracao(java.util.Date dataAlteracao) {
        _mensagem.setDataAlteracao(dataAlteracao);
    }

    /**
    * Returns the rascunho of this mensagem.
    *
    * @return the rascunho of this mensagem
    */
    @Override
    public boolean getRascunho() {
        return _mensagem.getRascunho();
    }

    /**
    * Returns <code>true</code> if this mensagem is rascunho.
    *
    * @return <code>true</code> if this mensagem is rascunho; <code>false</code> otherwise
    */
    @Override
    public boolean isRascunho() {
        return _mensagem.isRascunho();
    }

    /**
    * Sets whether this mensagem is rascunho.
    *
    * @param rascunho the rascunho of this mensagem
    */
    @Override
    public void setRascunho(boolean rascunho) {
        _mensagem.setRascunho(rascunho);
    }

    /**
    * Returns the status workflow of this mensagem.
    *
    * @return the status workflow of this mensagem
    */
    @Override
    public int getStatusWorkflow() {
        return _mensagem.getStatusWorkflow();
    }

    /**
    * Sets the status workflow of this mensagem.
    *
    * @param statusWorkflow the status workflow of this mensagem
    */
    @Override
    public void setStatusWorkflow(int statusWorkflow) {
        _mensagem.setStatusWorkflow(statusWorkflow);
    }

    /**
    * Returns the user ID workflow of this mensagem.
    *
    * @return the user ID workflow of this mensagem
    */
    @Override
    public long getUserIdWorkflow() {
        return _mensagem.getUserIdWorkflow();
    }

    /**
    * Sets the user ID workflow of this mensagem.
    *
    * @param userIdWorkflow the user ID workflow of this mensagem
    */
    @Override
    public void setUserIdWorkflow(long userIdWorkflow) {
        _mensagem.setUserIdWorkflow(userIdWorkflow);
    }

    /**
    * Returns the data status workflow of this mensagem.
    *
    * @return the data status workflow of this mensagem
    */
    @Override
    public java.util.Date getDataStatusWorkflow() {
        return _mensagem.getDataStatusWorkflow();
    }

    /**
    * Sets the data status workflow of this mensagem.
    *
    * @param dataStatusWorkflow the data status workflow of this mensagem
    */
    @Override
    public void setDataStatusWorkflow(java.util.Date dataStatusWorkflow) {
        _mensagem.setDataStatusWorkflow(dataStatusWorkflow);
    }

    /**
    * Returns the comentario workflow of this mensagem.
    *
    * @return the comentario workflow of this mensagem
    */
    @Override
    public java.lang.String getComentarioWorkflow() {
        return _mensagem.getComentarioWorkflow();
    }

    /**
    * Sets the comentario workflow of this mensagem.
    *
    * @param comentarioWorkflow the comentario workflow of this mensagem
    */
    @Override
    public void setComentarioWorkflow(java.lang.String comentarioWorkflow) {
        _mensagem.setComentarioWorkflow(comentarioWorkflow);
    }

    /**
    * Returns the clonagem pai of this mensagem.
    *
    * @return the clonagem pai of this mensagem
    */
    @Override
    public long getClonagemPai() {
        return _mensagem.getClonagemPai();
    }

    /**
    * Sets the clonagem pai of this mensagem.
    *
    * @param clonagemPai the clonagem pai of this mensagem
    */
    @Override
    public void setClonagemPai(long clonagemPai) {
        _mensagem.setClonagemPai(clonagemPai);
    }

    /**
    * Returns the literal agendamento of this mensagem.
    *
    * @return the literal agendamento of this mensagem
    */
    @Override
    public java.lang.String getLiteralAgendamento() {
        return _mensagem.getLiteralAgendamento();
    }

    /**
    * Sets the literal agendamento of this mensagem.
    *
    * @param literalAgendamento the literal agendamento of this mensagem
    */
    @Override
    public void setLiteralAgendamento(java.lang.String literalAgendamento) {
        _mensagem.setLiteralAgendamento(literalAgendamento);
    }

    /**
    * Returns the user ID cancel of this mensagem.
    *
    * @return the user ID cancel of this mensagem
    */
    @Override
    public long getUserIdCancel() {
        return _mensagem.getUserIdCancel();
    }

    /**
    * Sets the user ID cancel of this mensagem.
    *
    * @param userIdCancel the user ID cancel of this mensagem
    */
    @Override
    public void setUserIdCancel(long userIdCancel) {
        _mensagem.setUserIdCancel(userIdCancel);
    }

    /**
    * Returns the user ID aprovador of this mensagem.
    *
    * @return the user ID aprovador of this mensagem
    */
    @Override
    public long getUserIdAprovador() {
        return _mensagem.getUserIdAprovador();
    }

    /**
    * Sets the user ID aprovador of this mensagem.
    *
    * @param userIdAprovador the user ID aprovador of this mensagem
    */
    @Override
    public void setUserIdAprovador(long userIdAprovador) {
        _mensagem.setUserIdAprovador(userIdAprovador);
    }

    /**
    * Returns the user ID reprovador of this mensagem.
    *
    * @return the user ID reprovador of this mensagem
    */
    @Override
    public long getUserIdReprovador() {
        return _mensagem.getUserIdReprovador();
    }

    /**
    * Sets the user ID reprovador of this mensagem.
    *
    * @param userIdReprovador the user ID reprovador of this mensagem
    */
    @Override
    public void setUserIdReprovador(long userIdReprovador) {
        _mensagem.setUserIdReprovador(userIdReprovador);
    }

    /**
    * Returns the data cancel of this mensagem.
    *
    * @return the data cancel of this mensagem
    */
    @Override
    public java.util.Date getDataCancel() {
        return _mensagem.getDataCancel();
    }

    /**
    * Sets the data cancel of this mensagem.
    *
    * @param dataCancel the data cancel of this mensagem
    */
    @Override
    public void setDataCancel(java.util.Date dataCancel) {
        _mensagem.setDataCancel(dataCancel);
    }

    /**
    * Returns the service of this mensagem.
    *
    * @return the service of this mensagem
    */
    @Override
    public boolean getService() {
        return _mensagem.getService();
    }

    /**
    * Returns <code>true</code> if this mensagem is service.
    *
    * @return <code>true</code> if this mensagem is service; <code>false</code> otherwise
    */
    @Override
    public boolean isService() {
        return _mensagem.isService();
    }

    /**
    * Sets whether this mensagem is service.
    *
    * @param service the service of this mensagem
    */
    @Override
    public void setService(boolean service) {
        _mensagem.setService(service);
    }

    @Override
    public boolean isNew() {
        return _mensagem.isNew();
    }

    @Override
    public void setNew(boolean n) {
        _mensagem.setNew(n);
    }

    @Override
    public boolean isCachedModel() {
        return _mensagem.isCachedModel();
    }

    @Override
    public void setCachedModel(boolean cachedModel) {
        _mensagem.setCachedModel(cachedModel);
    }

    @Override
    public boolean isEscapedModel() {
        return _mensagem.isEscapedModel();
    }

    @Override
    public java.io.Serializable getPrimaryKeyObj() {
        return _mensagem.getPrimaryKeyObj();
    }

    @Override
    public void setPrimaryKeyObj(java.io.Serializable primaryKeyObj) {
        _mensagem.setPrimaryKeyObj(primaryKeyObj);
    }

    @Override
    public com.liferay.portlet.expando.model.ExpandoBridge getExpandoBridge() {
        return _mensagem.getExpandoBridge();
    }

    @Override
    public void setExpandoBridgeAttributes(
        com.liferay.portal.model.BaseModel<?> baseModel) {
        _mensagem.setExpandoBridgeAttributes(baseModel);
    }

    @Override
    public void setExpandoBridgeAttributes(
        com.liferay.portlet.expando.model.ExpandoBridge expandoBridge) {
        _mensagem.setExpandoBridgeAttributes(expandoBridge);
    }

    @Override
    public void setExpandoBridgeAttributes(
        com.liferay.portal.service.ServiceContext serviceContext) {
        _mensagem.setExpandoBridgeAttributes(serviceContext);
    }

    @Override
    public java.lang.Object clone() {
        return new MensagemWrapper((Mensagem) _mensagem.clone());
    }

    @Override
    public int compareTo(
        br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem mensagem) {
        return _mensagem.compareTo(mensagem);
    }

    @Override
    public int hashCode() {
        return _mensagem.hashCode();
    }

    @Override
    public com.liferay.portal.model.CacheModel<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem> toCacheModel() {
        return _mensagem.toCacheModel();
    }

    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem toEscapedModel() {
        return new MensagemWrapper(_mensagem.toEscapedModel());
    }

    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem toUnescapedModel() {
        return new MensagemWrapper(_mensagem.toUnescapedModel());
    }

    @Override
    public java.lang.String toString() {
        return _mensagem.toString();
    }

    @Override
    public java.lang.String toXmlString() {
        return _mensagem.toXmlString();
    }

    @Override
    public void persist()
        throws com.liferay.portal.kernel.exception.SystemException {
        _mensagem.persist();
    }

    @Override
    public void setTemplate(
        br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template template) {
        _mensagem.setTemplate(template);
    }

    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template getTemplate() {
        return _mensagem.getTemplate();
    }

    /**
    * Objeto com todas as informaÃƒÂ§ÃƒÂµes referentes ao agendamento: <br>
    * <ul>
    * <li>data/hora selecionadas no calendÃƒÂ¡rio</li>
    * <li>configuraÃƒÂ§ÃƒÂµes de recorrÃƒÂªncia</li>
    * <li>datas calculadas da recorrÃƒÂªncia</li>
    * </ul>
    */
    @Override
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> getAgendamentos() {
        return _mensagem.getAgendamentos();
    }

    @Override
    public void setAgendamentos(
        java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> agendamentos) {
        _mensagem.setAgendamentos(agendamentos);
    }

    /**
    * Informa&ccedil;&atilde;o auxiliar para identificar quais datas (sem a hora) foram
    * selecionadas no calend&aacute;rio. <br>
    * Cada entrada no Map principal utiliza a data no formato UNIX (GMT-3).<br>
    * O Map interno representa os horarios, identificados pelo texto representando a hora e contendo um objeto {@link Agendamento}.
    */
    @Override
    public java.util.Map<java.lang.Long, java.util.Map<java.lang.String, br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento>> getDatasCalendario() {
        return _mensagem.getDatasCalendario();
    }

    @Override
    public void setDatasCalendario(
        java.util.Map<java.lang.Long, java.util.Map<java.lang.String, br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento>> datasCalendario) {
        _mensagem.setDatasCalendario(datasCalendario);
    }

    @Override
    public boolean isGravarAgendamento() {
        return _mensagem.isGravarAgendamento();
    }

    @Override
    public void setGravarAgendamento(boolean gravarAgendamento) {
        _mensagem.setGravarAgendamento(gravarAgendamento);
    }

    @Override
    public java.lang.String getDescricaoStatus() {
        return _mensagem.getDescricaoStatus();
    }

    @Override
    public void setDescricaoStatus(java.lang.String descricaoStatus) {
        _mensagem.setDescricaoStatus(descricaoStatus);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }

        if (!(obj instanceof MensagemWrapper)) {
            return false;
        }

        MensagemWrapper mensagemWrapper = (MensagemWrapper) obj;

        if (Validator.equals(_mensagem, mensagemWrapper._mensagem)) {
            return true;
        }

        return false;
    }

    /**
     * @deprecated As of 6.1.0, replaced by {@link #getWrappedModel}
     */
    public Mensagem getWrappedMensagem() {
        return _mensagem;
    }

    @Override
    public Mensagem getWrappedModel() {
        return _mensagem;
    }

    @Override
    public void resetOriginalValues() {
        _mensagem.resetOriginalValues();
    }
}
