package br.mp.mprj.portal.portlet.gestaomensagens.service.model;

import com.liferay.portal.kernel.bean.AutoEscape;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;

import java.io.Serializable;

import java.util.Date;

/**
 * The base model interface for the Template service. Represents a row in the &quot;PRT_GESTMSG_TEMPLATE&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This interface and its corresponding implementation {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.TemplateModelImpl} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.TemplateImpl}.
 * </p>
 *
 * @author Henrique Simoes
 * @see Template
 * @see br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.TemplateImpl
 * @see br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.TemplateModelImpl
 * @generated
 */
public interface TemplateModel extends BaseModel<Template> {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this interface directly. All methods that expect a template model instance should use the {@link Template} interface instead.
     */

    /**
     * Returns the primary key of this template.
     *
     * @return the primary key of this template
     */
    public long getPrimaryKey();

    /**
     * Sets the primary key of this template.
     *
     * @param primaryKey the primary key of this template
     */
    public void setPrimaryKey(long primaryKey);

    /**
     * Returns the uuid of this template.
     *
     * @return the uuid of this template
     */
    @AutoEscape
    public String getUuid();

    /**
     * Sets the uuid of this template.
     *
     * @param uuid the uuid of this template
     */
    public void setUuid(String uuid);

    /**
     * Returns the template ID of this template.
     *
     * @return the template ID of this template
     */
    public long getTemplateId();

    /**
     * Sets the template ID of this template.
     *
     * @param templateId the template ID of this template
     */
    public void setTemplateId(long templateId);

    /**
     * Returns the company ID of this template.
     *
     * @return the company ID of this template
     */
    public long getCompanyId();

    /**
     * Sets the company ID of this template.
     *
     * @param companyId the company ID of this template
     */
    public void setCompanyId(long companyId);

    /**
     * Returns the group ID of this template.
     *
     * @return the group ID of this template
     */
    public long getGroupId();

    /**
     * Sets the group ID of this template.
     *
     * @param groupId the group ID of this template
     */
    public void setGroupId(long groupId);

    /**
     * Returns the user ID of this template.
     *
     * @return the user ID of this template
     */
    public long getUserId();

    /**
     * Sets the user ID of this template.
     *
     * @param userId the user ID of this template
     */
    public void setUserId(long userId);

    /**
     * Returns the user uuid of this template.
     *
     * @return the user uuid of this template
     * @throws SystemException if a system exception occurred
     */
    public String getUserUuid() throws SystemException;

    /**
     * Sets the user uuid of this template.
     *
     * @param userUuid the user uuid of this template
     */
    public void setUserUuid(String userUuid);

    /**
     * Returns the nome of this template.
     *
     * @return the nome of this template
     */
    @AutoEscape
    public String getNome();

    /**
     * Sets the nome of this template.
     *
     * @param nome the nome of this template
     */
    public void setNome(String nome);

    /**
     * Returns the estilo of this template.
     *
     * @return the estilo of this template
     */
    public int getEstilo();

    /**
     * Sets the estilo of this template.
     *
     * @param estilo the estilo of this template
     */
    public void setEstilo(int estilo);

    /**
     * Returns the ativo of this template.
     *
     * @return the ativo of this template
     */
    public boolean getAtivo();

    /**
     * Returns <code>true</code> if this template is ativo.
     *
     * @return <code>true</code> if this template is ativo; <code>false</code> otherwise
     */
    public boolean isAtivo();

    /**
     * Sets whether this template is ativo.
     *
     * @param ativo the ativo of this template
     */
    public void setAtivo(boolean ativo);

    /**
     * Returns the cabecalho of this template.
     *
     * @return the cabecalho of this template
     */
    @AutoEscape
    public String getCabecalho();

    /**
     * Sets the cabecalho of this template.
     *
     * @param cabecalho the cabecalho of this template
     */
    public void setCabecalho(String cabecalho);

    /**
     * Returns the rodape of this template.
     *
     * @return the rodape of this template
     */
    @AutoEscape
    public String getRodape();

    /**
     * Sets the rodape of this template.
     *
     * @param rodape the rodape of this template
     */
    public void setRodape(String rodape);

    /**
     * Returns the corpo of this template.
     *
     * @return the corpo of this template
     */
    @AutoEscape
    public String getCorpo();

    /**
     * Sets the corpo of this template.
     *
     * @param corpo the corpo of this template
     */
    public void setCorpo(String corpo);

    /**
     * Returns the data criacao of this template.
     *
     * @return the data criacao of this template
     */
    public Date getDataCriacao();

    /**
     * Sets the data criacao of this template.
     *
     * @param dataCriacao the data criacao of this template
     */
    public void setDataCriacao(Date dataCriacao);

    /**
     * Returns the data atualizacao of this template.
     *
     * @return the data atualizacao of this template
     */
    public Date getDataAtualizacao();

    /**
     * Sets the data atualizacao of this template.
     *
     * @param dataAtualizacao the data atualizacao of this template
     */
    public void setDataAtualizacao(Date dataAtualizacao);

    /**
     * Returns the thumbnail file entry ID of this template.
     *
     * @return the thumbnail file entry ID of this template
     */
    public long getThumbnailFileEntryId();

    /**
     * Sets the thumbnail file entry ID of this template.
     *
     * @param thumbnailFileEntryId the thumbnail file entry ID of this template
     */
    public void setThumbnailFileEntryId(long thumbnailFileEntryId);

    /**
     * Returns the thumbnail u r l of this template.
     *
     * @return the thumbnail u r l of this template
     */
    @AutoEscape
    public String getThumbnailURL();

    /**
     * Sets the thumbnail u r l of this template.
     *
     * @param thumbnailURL the thumbnail u r l of this template
     */
    public void setThumbnailURL(String thumbnailURL);

    @Override
    public boolean isNew();

    @Override
    public void setNew(boolean n);

    @Override
    public boolean isCachedModel();

    @Override
    public void setCachedModel(boolean cachedModel);

    @Override
    public boolean isEscapedModel();

    @Override
    public Serializable getPrimaryKeyObj();

    @Override
    public void setPrimaryKeyObj(Serializable primaryKeyObj);

    @Override
    public ExpandoBridge getExpandoBridge();

    @Override
    public void setExpandoBridgeAttributes(BaseModel<?> baseModel);

    @Override
    public void setExpandoBridgeAttributes(ExpandoBridge expandoBridge);

    @Override
    public void setExpandoBridgeAttributes(ServiceContext serviceContext);

    @Override
    public Object clone();

    @Override
    public int compareTo(
        br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template template);

    @Override
    public int hashCode();

    @Override
    public CacheModel<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template> toCacheModel();

    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template toEscapedModel();

    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template toUnescapedModel();

    @Override
    public String toString();

    @Override
    public String toXmlString();
}
