package br.mp.mprj.portal.portlet.gestaomensagens.service.service;

import com.liferay.portal.service.ServiceWrapper;

/**
 * Provides a wrapper for {@link AnexoMensagemLocalService}.
 *
 * @author Henrique Simoes
 * @see AnexoMensagemLocalService
 * @generated
 */
public class AnexoMensagemLocalServiceWrapper
    implements AnexoMensagemLocalService,
        ServiceWrapper<AnexoMensagemLocalService> {
    private AnexoMensagemLocalService _anexoMensagemLocalService;

    public AnexoMensagemLocalServiceWrapper(
        AnexoMensagemLocalService anexoMensagemLocalService) {
        _anexoMensagemLocalService = anexoMensagemLocalService;
    }

    /**
    * Adds the anexo mensagem to the database. Also notifies the appropriate model listeners.
    *
    * @param anexoMensagem the anexo mensagem
    * @return the anexo mensagem that was added
    * @throws SystemException if a system exception occurred
    */
    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem addAnexoMensagem(
        br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem anexoMensagem)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _anexoMensagemLocalService.addAnexoMensagem(anexoMensagem);
    }

    /**
    * Creates a new anexo mensagem with the primary key. Does not add the anexo mensagem to the database.
    *
    * @param anexoMensagemId the primary key for the new anexo mensagem
    * @return the new anexo mensagem
    */
    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem createAnexoMensagem(
        long anexoMensagemId) {
        return _anexoMensagemLocalService.createAnexoMensagem(anexoMensagemId);
    }

    /**
    * Deletes the anexo mensagem with the primary key from the database. Also notifies the appropriate model listeners.
    *
    * @param anexoMensagemId the primary key of the anexo mensagem
    * @return the anexo mensagem that was removed
    * @throws PortalException if a anexo mensagem with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem deleteAnexoMensagem(
        long anexoMensagemId)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException {
        return _anexoMensagemLocalService.deleteAnexoMensagem(anexoMensagemId);
    }

    /**
    * Deletes the anexo mensagem from the database. Also notifies the appropriate model listeners.
    *
    * @param anexoMensagem the anexo mensagem
    * @return the anexo mensagem that was removed
    * @throws SystemException if a system exception occurred
    */
    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem deleteAnexoMensagem(
        br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem anexoMensagem)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _anexoMensagemLocalService.deleteAnexoMensagem(anexoMensagem);
    }

    @Override
    public com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery() {
        return _anexoMensagemLocalService.dynamicQuery();
    }

    /**
    * Performs a dynamic query on the database and returns the matching rows.
    *
    * @param dynamicQuery the dynamic query
    * @return the matching rows
    * @throws SystemException if a system exception occurred
    */
    @Override
    @SuppressWarnings("rawtypes")
    public java.util.List dynamicQuery(
        com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _anexoMensagemLocalService.dynamicQuery(dynamicQuery);
    }

    /**
    * Performs a dynamic query on the database and returns a range of the matching rows.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AnexoMensagemModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param dynamicQuery the dynamic query
    * @param start the lower bound of the range of model instances
    * @param end the upper bound of the range of model instances (not inclusive)
    * @return the range of matching rows
    * @throws SystemException if a system exception occurred
    */
    @Override
    @SuppressWarnings("rawtypes")
    public java.util.List dynamicQuery(
        com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
        int end) throws com.liferay.portal.kernel.exception.SystemException {
        return _anexoMensagemLocalService.dynamicQuery(dynamicQuery, start, end);
    }

    /**
    * Performs a dynamic query on the database and returns an ordered range of the matching rows.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AnexoMensagemModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param dynamicQuery the dynamic query
    * @param start the lower bound of the range of model instances
    * @param end the upper bound of the range of model instances (not inclusive)
    * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
    * @return the ordered range of matching rows
    * @throws SystemException if a system exception occurred
    */
    @Override
    @SuppressWarnings("rawtypes")
    public java.util.List dynamicQuery(
        com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
        int end,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _anexoMensagemLocalService.dynamicQuery(dynamicQuery, start,
            end, orderByComparator);
    }

    /**
    * Returns the number of rows that match the dynamic query.
    *
    * @param dynamicQuery the dynamic query
    * @return the number of rows that match the dynamic query
    * @throws SystemException if a system exception occurred
    */
    @Override
    public long dynamicQueryCount(
        com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _anexoMensagemLocalService.dynamicQueryCount(dynamicQuery);
    }

    /**
    * Returns the number of rows that match the dynamic query.
    *
    * @param dynamicQuery the dynamic query
    * @param projection the projection to apply to the query
    * @return the number of rows that match the dynamic query
    * @throws SystemException if a system exception occurred
    */
    @Override
    public long dynamicQueryCount(
        com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery,
        com.liferay.portal.kernel.dao.orm.Projection projection)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _anexoMensagemLocalService.dynamicQueryCount(dynamicQuery,
            projection);
    }

    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem fetchAnexoMensagem(
        long anexoMensagemId)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _anexoMensagemLocalService.fetchAnexoMensagem(anexoMensagemId);
    }

    /**
    * Returns the anexo mensagem with the matching UUID and company.
    *
    * @param uuid the anexo mensagem's UUID
    * @param companyId the primary key of the company
    * @return the matching anexo mensagem, or <code>null</code> if a matching anexo mensagem could not be found
    * @throws SystemException if a system exception occurred
    */
    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem fetchAnexoMensagemByUuidAndCompanyId(
        java.lang.String uuid, long companyId)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _anexoMensagemLocalService.fetchAnexoMensagemByUuidAndCompanyId(uuid,
            companyId);
    }

    /**
    * Returns the anexo mensagem matching the UUID and group.
    *
    * @param uuid the anexo mensagem's UUID
    * @param groupId the primary key of the group
    * @return the matching anexo mensagem, or <code>null</code> if a matching anexo mensagem could not be found
    * @throws SystemException if a system exception occurred
    */
    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem fetchAnexoMensagemByUuidAndGroupId(
        java.lang.String uuid, long groupId)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _anexoMensagemLocalService.fetchAnexoMensagemByUuidAndGroupId(uuid,
            groupId);
    }

    /**
    * Returns the anexo mensagem with the primary key.
    *
    * @param anexoMensagemId the primary key of the anexo mensagem
    * @return the anexo mensagem
    * @throws PortalException if a anexo mensagem with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem getAnexoMensagem(
        long anexoMensagemId)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException {
        return _anexoMensagemLocalService.getAnexoMensagem(anexoMensagemId);
    }

    @Override
    public com.liferay.portal.model.PersistedModel getPersistedModel(
        java.io.Serializable primaryKeyObj)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException {
        return _anexoMensagemLocalService.getPersistedModel(primaryKeyObj);
    }

    /**
    * Returns the anexo mensagem with the matching UUID and company.
    *
    * @param uuid the anexo mensagem's UUID
    * @param companyId the primary key of the company
    * @return the matching anexo mensagem
    * @throws PortalException if a matching anexo mensagem could not be found
    * @throws SystemException if a system exception occurred
    */
    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem getAnexoMensagemByUuidAndCompanyId(
        java.lang.String uuid, long companyId)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException {
        return _anexoMensagemLocalService.getAnexoMensagemByUuidAndCompanyId(uuid,
            companyId);
    }

    /**
    * Returns the anexo mensagem matching the UUID and group.
    *
    * @param uuid the anexo mensagem's UUID
    * @param groupId the primary key of the group
    * @return the matching anexo mensagem
    * @throws PortalException if a matching anexo mensagem could not be found
    * @throws SystemException if a system exception occurred
    */
    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem getAnexoMensagemByUuidAndGroupId(
        java.lang.String uuid, long groupId)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException {
        return _anexoMensagemLocalService.getAnexoMensagemByUuidAndGroupId(uuid,
            groupId);
    }

    /**
    * Returns a range of all the anexo mensagems.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AnexoMensagemModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param start the lower bound of the range of anexo mensagems
    * @param end the upper bound of the range of anexo mensagems (not inclusive)
    * @return the range of anexo mensagems
    * @throws SystemException if a system exception occurred
    */
    @Override
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem> getAnexoMensagems(
        int start, int end)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _anexoMensagemLocalService.getAnexoMensagems(start, end);
    }

    /**
    * Returns the number of anexo mensagems.
    *
    * @return the number of anexo mensagems
    * @throws SystemException if a system exception occurred
    */
    @Override
    public int getAnexoMensagemsCount()
        throws com.liferay.portal.kernel.exception.SystemException {
        return _anexoMensagemLocalService.getAnexoMensagemsCount();
    }

    /**
    * Updates the anexo mensagem in the database or adds it if it does not yet exist. Also notifies the appropriate model listeners.
    *
    * @param anexoMensagem the anexo mensagem
    * @return the anexo mensagem that was updated
    * @throws SystemException if a system exception occurred
    */
    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem updateAnexoMensagem(
        br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem anexoMensagem)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _anexoMensagemLocalService.updateAnexoMensagem(anexoMensagem);
    }

    /**
    * Returns the Spring bean ID for this bean.
    *
    * @return the Spring bean ID for this bean
    */
    @Override
    public java.lang.String getBeanIdentifier() {
        return _anexoMensagemLocalService.getBeanIdentifier();
    }

    /**
    * Sets the Spring bean ID for this bean.
    *
    * @param beanIdentifier the Spring bean ID for this bean
    */
    @Override
    public void setBeanIdentifier(java.lang.String beanIdentifier) {
        _anexoMensagemLocalService.setBeanIdentifier(beanIdentifier);
    }

    @Override
    public java.lang.Object invokeMethod(java.lang.String name,
        java.lang.String[] parameterTypes, java.lang.Object[] arguments)
        throws java.lang.Throwable {
        return _anexoMensagemLocalService.invokeMethod(name, parameterTypes,
            arguments);
    }

    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem criarAnexo(
        javax.portlet.PortletRequest req)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _anexoMensagemLocalService.criarAnexo(req);
    }

    /**
    * Metodo responsavel por atualizar os anexos na base de dados.
    */
    @Override
    public void atualizaAnexos(
        java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem> anexos)
        throws com.liferay.portal.kernel.exception.SystemException {
        _anexoMensagemLocalService.atualizaAnexos(anexos);
    }

    /**
    * Metodo responsavel por remover os anexos de uma mensagem.
    */
    @Override
    public void removeAnexos(
        java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem> anexos)
        throws com.liferay.portal.kernel.exception.SystemException {
        _anexoMensagemLocalService.removeAnexos(anexos);
    }

    /**
    * Metodo responsavel em recuperar todos anexos de uma mensagem.
    *
    * @param mensagemId - identificado da mensagem.
    * @return List<AnexoMensagem> - retorna uma lista de anexos.
    * @throws SystemException - Em caso de falha.
    */
    @Override
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem> recuperaAnexosPorMensagem(
        long mensagemId)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _anexoMensagemLocalService.recuperaAnexosPorMensagem(mensagemId);
    }

    /**
     * @deprecated As of 6.1.0, replaced by {@link #getWrappedService}
     */
    public AnexoMensagemLocalService getWrappedAnexoMensagemLocalService() {
        return _anexoMensagemLocalService;
    }

    /**
     * @deprecated As of 6.1.0, replaced by {@link #setWrappedService}
     */
    public void setWrappedAnexoMensagemLocalService(
        AnexoMensagemLocalService anexoMensagemLocalService) {
        _anexoMensagemLocalService = anexoMensagemLocalService;
    }

    @Override
    public AnexoMensagemLocalService getWrappedService() {
        return _anexoMensagemLocalService;
    }

    @Override
    public void setWrappedService(
        AnexoMensagemLocalService anexoMensagemLocalService) {
        _anexoMensagemLocalService = anexoMensagemLocalService;
    }
}
