package br.mp.mprj.portal.portlet.gestaomensagens.service.service;

import com.liferay.portal.service.ServiceWrapper;

/**
 * Provides a wrapper for {@link MensagemLocalService}.
 *
 * @author Henrique Simoes
 * @see MensagemLocalService
 * @generated
 */
public class MensagemLocalServiceWrapper implements MensagemLocalService,
    ServiceWrapper<MensagemLocalService> {
    private MensagemLocalService _mensagemLocalService;

    public MensagemLocalServiceWrapper(
        MensagemLocalService mensagemLocalService) {
        _mensagemLocalService = mensagemLocalService;
    }

    /**
    * Adds the mensagem to the database. Also notifies the appropriate model listeners.
    *
    * @param mensagem the mensagem
    * @return the mensagem that was added
    * @throws SystemException if a system exception occurred
    */
    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem addMensagem(
        br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem mensagem)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _mensagemLocalService.addMensagem(mensagem);
    }

    /**
    * Creates a new mensagem with the primary key. Does not add the mensagem to the database.
    *
    * @param mensagemId the primary key for the new mensagem
    * @return the new mensagem
    */
    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem createMensagem(
        long mensagemId) {
        return _mensagemLocalService.createMensagem(mensagemId);
    }

    /**
    * Deletes the mensagem with the primary key from the database. Also notifies the appropriate model listeners.
    *
    * @param mensagemId the primary key of the mensagem
    * @return the mensagem that was removed
    * @throws PortalException if a mensagem with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem deleteMensagem(
        long mensagemId)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException {
        return _mensagemLocalService.deleteMensagem(mensagemId);
    }

    /**
    * Deletes the mensagem from the database. Also notifies the appropriate model listeners.
    *
    * @param mensagem the mensagem
    * @return the mensagem that was removed
    * @throws SystemException if a system exception occurred
    */
    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem deleteMensagem(
        br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem mensagem)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _mensagemLocalService.deleteMensagem(mensagem);
    }

    @Override
    public com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery() {
        return _mensagemLocalService.dynamicQuery();
    }

    /**
    * Performs a dynamic query on the database and returns the matching rows.
    *
    * @param dynamicQuery the dynamic query
    * @return the matching rows
    * @throws SystemException if a system exception occurred
    */
    @Override
    @SuppressWarnings("rawtypes")
    public java.util.List dynamicQuery(
        com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _mensagemLocalService.dynamicQuery(dynamicQuery);
    }

    /**
    * Performs a dynamic query on the database and returns a range of the matching rows.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.MensagemModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param dynamicQuery the dynamic query
    * @param start the lower bound of the range of model instances
    * @param end the upper bound of the range of model instances (not inclusive)
    * @return the range of matching rows
    * @throws SystemException if a system exception occurred
    */
    @Override
    @SuppressWarnings("rawtypes")
    public java.util.List dynamicQuery(
        com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
        int end) throws com.liferay.portal.kernel.exception.SystemException {
        return _mensagemLocalService.dynamicQuery(dynamicQuery, start, end);
    }

    /**
    * Performs a dynamic query on the database and returns an ordered range of the matching rows.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.MensagemModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param dynamicQuery the dynamic query
    * @param start the lower bound of the range of model instances
    * @param end the upper bound of the range of model instances (not inclusive)
    * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
    * @return the ordered range of matching rows
    * @throws SystemException if a system exception occurred
    */
    @Override
    @SuppressWarnings("rawtypes")
    public java.util.List dynamicQuery(
        com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
        int end,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _mensagemLocalService.dynamicQuery(dynamicQuery, start, end,
            orderByComparator);
    }

    /**
    * Returns the number of rows that match the dynamic query.
    *
    * @param dynamicQuery the dynamic query
    * @return the number of rows that match the dynamic query
    * @throws SystemException if a system exception occurred
    */
    @Override
    public long dynamicQueryCount(
        com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _mensagemLocalService.dynamicQueryCount(dynamicQuery);
    }

    /**
    * Returns the number of rows that match the dynamic query.
    *
    * @param dynamicQuery the dynamic query
    * @param projection the projection to apply to the query
    * @return the number of rows that match the dynamic query
    * @throws SystemException if a system exception occurred
    */
    @Override
    public long dynamicQueryCount(
        com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery,
        com.liferay.portal.kernel.dao.orm.Projection projection)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _mensagemLocalService.dynamicQueryCount(dynamicQuery, projection);
    }

    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem fetchMensagem(
        long mensagemId)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _mensagemLocalService.fetchMensagem(mensagemId);
    }

    /**
    * Returns the mensagem with the matching UUID and company.
    *
    * @param uuid the mensagem's UUID
    * @param companyId the primary key of the company
    * @return the matching mensagem, or <code>null</code> if a matching mensagem could not be found
    * @throws SystemException if a system exception occurred
    */
    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem fetchMensagemByUuidAndCompanyId(
        java.lang.String uuid, long companyId)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _mensagemLocalService.fetchMensagemByUuidAndCompanyId(uuid,
            companyId);
    }

    /**
    * Returns the mensagem matching the UUID and group.
    *
    * @param uuid the mensagem's UUID
    * @param groupId the primary key of the group
    * @return the matching mensagem, or <code>null</code> if a matching mensagem could not be found
    * @throws SystemException if a system exception occurred
    */
    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem fetchMensagemByUuidAndGroupId(
        java.lang.String uuid, long groupId)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _mensagemLocalService.fetchMensagemByUuidAndGroupId(uuid, groupId);
    }

    /**
    * Returns the mensagem with the primary key.
    *
    * @param mensagemId the primary key of the mensagem
    * @return the mensagem
    * @throws PortalException if a mensagem with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem getMensagem(
        long mensagemId)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException {
        return _mensagemLocalService.getMensagem(mensagemId);
    }

    @Override
    public com.liferay.portal.model.PersistedModel getPersistedModel(
        java.io.Serializable primaryKeyObj)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException {
        return _mensagemLocalService.getPersistedModel(primaryKeyObj);
    }

    /**
    * Returns the mensagem with the matching UUID and company.
    *
    * @param uuid the mensagem's UUID
    * @param companyId the primary key of the company
    * @return the matching mensagem
    * @throws PortalException if a matching mensagem could not be found
    * @throws SystemException if a system exception occurred
    */
    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem getMensagemByUuidAndCompanyId(
        java.lang.String uuid, long companyId)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException {
        return _mensagemLocalService.getMensagemByUuidAndCompanyId(uuid,
            companyId);
    }

    /**
    * Returns the mensagem matching the UUID and group.
    *
    * @param uuid the mensagem's UUID
    * @param groupId the primary key of the group
    * @return the matching mensagem
    * @throws PortalException if a matching mensagem could not be found
    * @throws SystemException if a system exception occurred
    */
    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem getMensagemByUuidAndGroupId(
        java.lang.String uuid, long groupId)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException {
        return _mensagemLocalService.getMensagemByUuidAndGroupId(uuid, groupId);
    }

    /**
    * Returns a range of all the mensagems.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.MensagemModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param start the lower bound of the range of mensagems
    * @param end the upper bound of the range of mensagems (not inclusive)
    * @return the range of mensagems
    * @throws SystemException if a system exception occurred
    */
    @Override
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem> getMensagems(
        int start, int end)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _mensagemLocalService.getMensagems(start, end);
    }

    /**
    * Returns the number of mensagems.
    *
    * @return the number of mensagems
    * @throws SystemException if a system exception occurred
    */
    @Override
    public int getMensagemsCount()
        throws com.liferay.portal.kernel.exception.SystemException {
        return _mensagemLocalService.getMensagemsCount();
    }

    /**
    * Updates the mensagem in the database or adds it if it does not yet exist. Also notifies the appropriate model listeners.
    *
    * @param mensagem the mensagem
    * @return the mensagem that was updated
    * @throws SystemException if a system exception occurred
    */
    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem updateMensagem(
        br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem mensagem)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _mensagemLocalService.updateMensagem(mensagem);
    }

    /**
    * Returns the Spring bean ID for this bean.
    *
    * @return the Spring bean ID for this bean
    */
    @Override
    public java.lang.String getBeanIdentifier() {
        return _mensagemLocalService.getBeanIdentifier();
    }

    /**
    * Sets the Spring bean ID for this bean.
    *
    * @param beanIdentifier the Spring bean ID for this bean
    */
    @Override
    public void setBeanIdentifier(java.lang.String beanIdentifier) {
        _mensagemLocalService.setBeanIdentifier(beanIdentifier);
    }

    @Override
    public java.lang.Object invokeMethod(java.lang.String name,
        java.lang.String[] parameterTypes, java.lang.Object[] arguments)
        throws java.lang.Throwable {
        return _mensagemLocalService.invokeMethod(name, parameterTypes,
            arguments);
    }

    /**
    * Retorna a mensagem de rascunho do usuario criador informado.
    *
    * @param userIdCriador
    * @return {@link Mensagem}
    * @throws PortalException
    * @throws SystemException
    */
    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem getRascunho(
        long userIdCriador)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException {
        return _mensagemLocalService.getRascunho(userIdCriador);
    }

    /**
    * Tenta recuperar a mensagem de rascunho, caso nao exista, tenta recuperar a mensagem da sessao.
    */
    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem getMensagem(
        com.liferay.portal.kernel.upload.UploadPortletRequest uploadReq,
        javax.portlet.PortletRequest req)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException {
        return _mensagemLocalService.getMensagem(uploadReq, req);
    }

    /**
    * Tenta recuperar a mensagem de rascunho, caso nao exista, tenta recuperar a mensagem da sessao.
    */
    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem getMensagem(
        javax.portlet.PortletRequest req)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException {
        return _mensagemLocalService.getMensagem(req);
    }

    /**
    * Retorna se est&aacute; no modo wizard rascunho, ou se est&aacute;
    * editando alguma mensagem previamente gravada (geralmente voltando ao fluxo de aprova&ccedil;&atilde;o).
    */
    @Override
    public boolean isRascunho(javax.portlet.PortletRequest req) {
        return _mensagemLocalService.isRascunho(req);
    }

    /**
    * Metodo responsavel pelo cancelamento de todos os seus agendamentos pendentes da mensagem.
    */
    @Override
    public void cancelarMensagem(long mensagemId)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException {
        _mensagemLocalService.cancelarMensagem(mensagemId);
    }

    /**
    * Metodo responsavel pela clonagem de uma mensagem existente
    * e todos os seus agendamentos pendentes.
    */
    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem clonaMensagem(
        long mensagemId, javax.portlet.PortletRequest req)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException {
        return _mensagemLocalService.clonaMensagem(mensagemId, req);
    }

    /**
     * @deprecated As of 6.1.0, replaced by {@link #getWrappedService}
     */
    public MensagemLocalService getWrappedMensagemLocalService() {
        return _mensagemLocalService;
    }

    /**
     * @deprecated As of 6.1.0, replaced by {@link #setWrappedService}
     */
    public void setWrappedMensagemLocalService(
        MensagemLocalService mensagemLocalService) {
        _mensagemLocalService = mensagemLocalService;
    }

    @Override
    public MensagemLocalService getWrappedService() {
        return _mensagemLocalService;
    }

    @Override
    public void setWrappedService(MensagemLocalService mensagemLocalService) {
        _mensagemLocalService = mensagemLocalService;
    }
}
