package br.mp.mprj.portal.portlet.gestaomensagens.service.service;

import com.liferay.portal.service.ServiceWrapper;

/**
 * Provides a wrapper for {@link MensagemService}.
 *
 * @author Henrique Simoes
 * @see MensagemService
 * @generated
 */
public class MensagemServiceWrapper implements MensagemService,
    ServiceWrapper<MensagemService> {
    private MensagemService _mensagemService;

    public MensagemServiceWrapper(MensagemService mensagemService) {
        _mensagemService = mensagemService;
    }

    /**
    * Returns the Spring bean ID for this bean.
    *
    * @return the Spring bean ID for this bean
    */
    @Override
    public java.lang.String getBeanIdentifier() {
        return _mensagemService.getBeanIdentifier();
    }

    /**
    * Sets the Spring bean ID for this bean.
    *
    * @param beanIdentifier the Spring bean ID for this bean
    */
    @Override
    public void setBeanIdentifier(java.lang.String beanIdentifier) {
        _mensagemService.setBeanIdentifier(beanIdentifier);
    }

    @Override
    public java.lang.Object invokeMethod(java.lang.String name,
        java.lang.String[] parameterTypes, java.lang.Object[] arguments)
        throws java.lang.Throwable {
        return _mensagemService.invokeMethod(name, parameterTypes, arguments);
    }

    /**
    * Servico responsavel por criar e enviar uma mensagem.
    *
    * @param assunto - Assunto da mensagem.
    * @param conteudo - HTML ou texto da mensagem.
    * @param nomeSolicitante - Nome do responsavel pela solicitacao da mensagem.
    * @param emailSolicitante - Email do solicitante.
    * @param contaDeSaidaId - Indetificador da Conta de Saida.
    * @param prioridade - Prioridade da Mensagem.
    * @param listaDestinatarioIds - Identificadores das listas de Destinatarios.
    * @param userId - Identificador do usuario no Liferay.
    * @param groupId - Identificador do Grupo do Usuario no Liferay.
    * @param companyId - Identificador da Empresa no Liferay.
    * @throws SystemException - Em caso de falha.
    Url de chamada do envia-mensagem WS : http://servidor/api/jsonws/invoke
    */
    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.ws.vo.MensagemRetorno enviaMensagem(
        java.lang.String assunto, java.lang.String conteudo,
        java.lang.String nomeSolicitante, java.lang.String emailSolicitante,
        long contaDeSaidaId, int prioridade,
        java.lang.String listaDestinatarioIds, java.lang.String dataHoraEnvio) {
        return _mensagemService.enviaMensagem(assunto, conteudo,
            nomeSolicitante, emailSolicitante, contaDeSaidaId, prioridade,
            listaDestinatarioIds, dataHoraEnvio);
    }

    /**
     * @deprecated As of 6.1.0, replaced by {@link #getWrappedService}
     */
    public MensagemService getWrappedMensagemService() {
        return _mensagemService;
    }

    /**
     * @deprecated As of 6.1.0, replaced by {@link #setWrappedService}
     */
    public void setWrappedMensagemService(MensagemService mensagemService) {
        _mensagemService = mensagemService;
    }

    @Override
    public MensagemService getWrappedService() {
        return _mensagemService;
    }

    @Override
    public void setWrappedService(MensagemService mensagemService) {
        _mensagemService = mensagemService;
    }
}
