package br.mp.mprj.portal.portlet.gestaomensagens.service.service;

import com.liferay.portal.service.ServiceWrapper;

/**
 * Provides a wrapper for {@link MensagemWorkflowLocalService}.
 *
 * @author Henrique Simoes
 * @see MensagemWorkflowLocalService
 * @generated
 */
public class MensagemWorkflowLocalServiceWrapper
    implements MensagemWorkflowLocalService,
        ServiceWrapper<MensagemWorkflowLocalService> {
    private MensagemWorkflowLocalService _mensagemWorkflowLocalService;

    public MensagemWorkflowLocalServiceWrapper(
        MensagemWorkflowLocalService mensagemWorkflowLocalService) {
        _mensagemWorkflowLocalService = mensagemWorkflowLocalService;
    }

    /**
    * Adds the mensagem workflow to the database. Also notifies the appropriate model listeners.
    *
    * @param mensagemWorkflow the mensagem workflow
    * @return the mensagem workflow that was added
    * @throws SystemException if a system exception occurred
    */
    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.MensagemWorkflow addMensagemWorkflow(
        br.mp.mprj.portal.portlet.gestaomensagens.service.model.MensagemWorkflow mensagemWorkflow)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _mensagemWorkflowLocalService.addMensagemWorkflow(mensagemWorkflow);
    }

    /**
    * Creates a new mensagem workflow with the primary key. Does not add the mensagem workflow to the database.
    *
    * @param mensagemWorkflowId the primary key for the new mensagem workflow
    * @return the new mensagem workflow
    */
    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.MensagemWorkflow createMensagemWorkflow(
        long mensagemWorkflowId) {
        return _mensagemWorkflowLocalService.createMensagemWorkflow(mensagemWorkflowId);
    }

    /**
    * Deletes the mensagem workflow with the primary key from the database. Also notifies the appropriate model listeners.
    *
    * @param mensagemWorkflowId the primary key of the mensagem workflow
    * @return the mensagem workflow that was removed
    * @throws PortalException if a mensagem workflow with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.MensagemWorkflow deleteMensagemWorkflow(
        long mensagemWorkflowId)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException {
        return _mensagemWorkflowLocalService.deleteMensagemWorkflow(mensagemWorkflowId);
    }

    /**
    * Deletes the mensagem workflow from the database. Also notifies the appropriate model listeners.
    *
    * @param mensagemWorkflow the mensagem workflow
    * @return the mensagem workflow that was removed
    * @throws SystemException if a system exception occurred
    */
    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.MensagemWorkflow deleteMensagemWorkflow(
        br.mp.mprj.portal.portlet.gestaomensagens.service.model.MensagemWorkflow mensagemWorkflow)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _mensagemWorkflowLocalService.deleteMensagemWorkflow(mensagemWorkflow);
    }

    @Override
    public com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery() {
        return _mensagemWorkflowLocalService.dynamicQuery();
    }

    /**
    * Performs a dynamic query on the database and returns the matching rows.
    *
    * @param dynamicQuery the dynamic query
    * @return the matching rows
    * @throws SystemException if a system exception occurred
    */
    @Override
    @SuppressWarnings("rawtypes")
    public java.util.List dynamicQuery(
        com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _mensagemWorkflowLocalService.dynamicQuery(dynamicQuery);
    }

    /**
    * Performs a dynamic query on the database and returns a range of the matching rows.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.MensagemWorkflowModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param dynamicQuery the dynamic query
    * @param start the lower bound of the range of model instances
    * @param end the upper bound of the range of model instances (not inclusive)
    * @return the range of matching rows
    * @throws SystemException if a system exception occurred
    */
    @Override
    @SuppressWarnings("rawtypes")
    public java.util.List dynamicQuery(
        com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
        int end) throws com.liferay.portal.kernel.exception.SystemException {
        return _mensagemWorkflowLocalService.dynamicQuery(dynamicQuery, start,
            end);
    }

    /**
    * Performs a dynamic query on the database and returns an ordered range of the matching rows.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.MensagemWorkflowModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param dynamicQuery the dynamic query
    * @param start the lower bound of the range of model instances
    * @param end the upper bound of the range of model instances (not inclusive)
    * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
    * @return the ordered range of matching rows
    * @throws SystemException if a system exception occurred
    */
    @Override
    @SuppressWarnings("rawtypes")
    public java.util.List dynamicQuery(
        com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
        int end,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _mensagemWorkflowLocalService.dynamicQuery(dynamicQuery, start,
            end, orderByComparator);
    }

    /**
    * Returns the number of rows that match the dynamic query.
    *
    * @param dynamicQuery the dynamic query
    * @return the number of rows that match the dynamic query
    * @throws SystemException if a system exception occurred
    */
    @Override
    public long dynamicQueryCount(
        com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _mensagemWorkflowLocalService.dynamicQueryCount(dynamicQuery);
    }

    /**
    * Returns the number of rows that match the dynamic query.
    *
    * @param dynamicQuery the dynamic query
    * @param projection the projection to apply to the query
    * @return the number of rows that match the dynamic query
    * @throws SystemException if a system exception occurred
    */
    @Override
    public long dynamicQueryCount(
        com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery,
        com.liferay.portal.kernel.dao.orm.Projection projection)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _mensagemWorkflowLocalService.dynamicQueryCount(dynamicQuery,
            projection);
    }

    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.MensagemWorkflow fetchMensagemWorkflow(
        long mensagemWorkflowId)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _mensagemWorkflowLocalService.fetchMensagemWorkflow(mensagemWorkflowId);
    }

    /**
    * Returns the mensagem workflow with the primary key.
    *
    * @param mensagemWorkflowId the primary key of the mensagem workflow
    * @return the mensagem workflow
    * @throws PortalException if a mensagem workflow with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.MensagemWorkflow getMensagemWorkflow(
        long mensagemWorkflowId)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException {
        return _mensagemWorkflowLocalService.getMensagemWorkflow(mensagemWorkflowId);
    }

    @Override
    public com.liferay.portal.model.PersistedModel getPersistedModel(
        java.io.Serializable primaryKeyObj)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException {
        return _mensagemWorkflowLocalService.getPersistedModel(primaryKeyObj);
    }

    /**
    * Returns a range of all the mensagem workflows.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.MensagemWorkflowModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param start the lower bound of the range of mensagem workflows
    * @param end the upper bound of the range of mensagem workflows (not inclusive)
    * @return the range of mensagem workflows
    * @throws SystemException if a system exception occurred
    */
    @Override
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.MensagemWorkflow> getMensagemWorkflows(
        int start, int end)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _mensagemWorkflowLocalService.getMensagemWorkflows(start, end);
    }

    /**
    * Returns the number of mensagem workflows.
    *
    * @return the number of mensagem workflows
    * @throws SystemException if a system exception occurred
    */
    @Override
    public int getMensagemWorkflowsCount()
        throws com.liferay.portal.kernel.exception.SystemException {
        return _mensagemWorkflowLocalService.getMensagemWorkflowsCount();
    }

    /**
    * Updates the mensagem workflow in the database or adds it if it does not yet exist. Also notifies the appropriate model listeners.
    *
    * @param mensagemWorkflow the mensagem workflow
    * @return the mensagem workflow that was updated
    * @throws SystemException if a system exception occurred
    */
    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.MensagemWorkflow updateMensagemWorkflow(
        br.mp.mprj.portal.portlet.gestaomensagens.service.model.MensagemWorkflow mensagemWorkflow)
        throws com.liferay.portal.kernel.exception.SystemException {
        return _mensagemWorkflowLocalService.updateMensagemWorkflow(mensagemWorkflow);
    }

    /**
    * Returns the Spring bean ID for this bean.
    *
    * @return the Spring bean ID for this bean
    */
    @Override
    public java.lang.String getBeanIdentifier() {
        return _mensagemWorkflowLocalService.getBeanIdentifier();
    }

    /**
    * Sets the Spring bean ID for this bean.
    *
    * @param beanIdentifier the Spring bean ID for this bean
    */
    @Override
    public void setBeanIdentifier(java.lang.String beanIdentifier) {
        _mensagemWorkflowLocalService.setBeanIdentifier(beanIdentifier);
    }

    @Override
    public java.lang.Object invokeMethod(java.lang.String name,
        java.lang.String[] parameterTypes, java.lang.Object[] arguments)
        throws java.lang.Throwable {
        return _mensagemWorkflowLocalService.invokeMethod(name, parameterTypes,
            arguments);
    }

    @Override
    public void gravarHistoricoWorkflow(
        br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem mensagem)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException {
        _mensagemWorkflowLocalService.gravarHistoricoWorkflow(mensagem);
    }

    /**
     * @deprecated As of 6.1.0, replaced by {@link #getWrappedService}
     */
    public MensagemWorkflowLocalService getWrappedMensagemWorkflowLocalService() {
        return _mensagemWorkflowLocalService;
    }

    /**
     * @deprecated As of 6.1.0, replaced by {@link #setWrappedService}
     */
    public void setWrappedMensagemWorkflowLocalService(
        MensagemWorkflowLocalService mensagemWorkflowLocalService) {
        _mensagemWorkflowLocalService = mensagemWorkflowLocalService;
    }

    @Override
    public MensagemWorkflowLocalService getWrappedService() {
        return _mensagemWorkflowLocalService;
    }

    @Override
    public void setWrappedService(
        MensagemWorkflowLocalService mensagemWorkflowLocalService) {
        _mensagemWorkflowLocalService = mensagemWorkflowLocalService;
    }
}
